section .data
	msg1:	db 10,"Reading the file: "	; the string to print, 10=cr
	lenmsg1:	equ $-msg1	; "$" means "here"
	msg2:	db 10,10,"Printing the file content..",10	; printing file content
	lenmsg2:	equ $-msg2	; "$" means "here"
	bufsize: dw 2048	;The size of the buffer!
section .bss
	filename: resb 2048
	buffer: resb 2048
section	.text	; declaring our .text segment
		global	_start	; telling where program execution should start

_start:
	mov	rdx,lenmsg1 ; arg3, length of string to print
	mov	rcx,msg1	; arg2, pointer to string
	mov	rbx,1		; arg1, where to write, screen
	mov	rax,4		; write sysout command to int 80 hex
	int	0x80		; interrupt 80 hex, call kernel
	pop rcx			;Program Filename
	pop rcx			;ARGC, tells the number of ARGV
	pop rcx 		; ARGV[1] pointer!

	mov rdi, filename   ;RDI is the filename pointer
	mov	rsi,rcx  		;RSI is the argv[1] pointer
	mov rdx,0			;Counter register used RdX
argv1l:
	mov rax,[rsi]		;Move the argv[1][x] to RAX
	cmp rax,0
	je	print1			;IF zero goes to print1
	mov	[rdi],AL		;put the argv[1][x] into the buffer
	inc	rsi
	inc	rdi
	inc	rdx
	jmp	argv1l
print1:
	mov	rdx,0			;Print Count setted to 0
	mov	rdi, filename	;Search for..
print2:
; PRINT FUNCTION! SECONDO CONTROLLO
	mov rax, [rdi]
	inc	rdi
	inc	rdx
	cmp	rax,0
	je	printok
	jmp	print2		
printok:
	;rdx contain the length of string to print
	mov	rcx,filename; arg2, pointer to string
	mov	rbx,1		; arg1, where to write, screen
	mov	rax,4		; write sysout command to int 80 hex
	int	0x80		; interrupt 80 hex, call kernel

; OPEN A FILE FUNCTION
	mov	rax,5			; the syscall number for open()
	mov	rbx,filename	; File Name pointer
	mov	rcx,2			; Read Write
	int	80h				; call the kernel

	test rax,rax		; lets make sure it is valid
	jns	 readstart		; if the file descriptor does not have the
						; sign flag ( which means it is less than 0 )
						; jump to file_function
	mov	rbx,rax			; there was an error, save the errno in ebx
	mov	eax,1			; put the exit syscall number in eax
	int	80h				; bail out
readstart:
	push	rax
	call	print_read_msg
	pop	rax

;READ FROM THE FILE
	mov	rbx,rax		; sys_open returned file descriptor into eax
readloop:
	push	rbx
	mov	rax,3		; sys_read  
					; rbx is already setup
	mov	rcx,buffer	; we are putting the ADDRESS of buf in ecx
	mov	rdx,bufsize	; we are putting the ADDRESS of bufsize in edx	
	int 	80h		; call the kernel
printbuffer:
; PRINT FUNCTION!
	mov	rdx,rax		; arg3, length of string to print
;	mov	rdx,1		; arg3, length of string to print
	mov	rcx,buffer	; arg2, pointer to string
	mov	rbx,1		; arg1, where to write, screen
	mov	rax,4		; write sysout command to int 80 hex
	int	0x80		; interrupt 80 hex, call kernel
	pop	rbx
	test	rax,rax	; see what got returned
	jz	exit	; got an EOF, go to read the next file
	js	exit	; got error
	jmp	readloop

exit:
;RETURN KERNEL INTERRUPT
	mov	rbx,0		; exit code, 0=normal
	mov	rax,1		; exit command to kernel
	int	0x80		; interrupt 80 hex, call kernel
